
/* Control the different menu-popups for Thunderbird/mail
 * 	for References, Reminders and ICS-attachements
 * 
 *	@thisId	indicates the 'source' or the id of the menu called from
 * 	attachmentListContext 	('List')
 * 	threadPaneContext 		('Thread')
 * 	messagePaneContext 		('Msg')
 */
function rmFxPopupCheck(thisId){
	var dMode = true;
	var nReferences = "";
	var rmFxID="";
	
	if (thisId.id == "threadPaneContext") 		{ var xulId = "Thread";}
	if (thisId.id == "messagePaneContext") 	{ var xulId = "Msg";}
	if (thisId.id == "attachmentListContext") { var xulId = "List";}  //?? required ??
 
	// ----  check 'attachment(s)' for ICS reminders  ---- 	
	if ((xulId == "Msg") || (xulId == "List")) {
		if (currentAttachments.length > 0) { 
			var i=0;
			while (i < currentAttachments.length) {		
				if (   (currentAttachments[i].contentType == "text/calendar") 	/* 'normal apps */					
					 || (currentAttachments[i].contentType == "application/ics") /* Google Calendar */ 	
					) {dMode = false;}
				i++;
			}		
		}	
		if (dMode == false) {
			document.getElementById("mailRm_ICS_" +xulId).removeAttribute("disabled");
		} else {
			document.getElementById("mailRm_ICS_" +xulId).setAttribute("disabled", "true");			
		}
	}
				
	var dMode = true;

	// ---- check message for 'References' and/or 'Reminders'  ---- 		
	if ((xulId == "Thread") || (xulId == "Msg")) {
		
		// ---- check for 'References' ----------
		var msgHdr = gDBView.hdrForFirstSelectedMessage;
		
		if ((msgHdr.numReferences > 0)) {			
			for (var n=0; n< msgHdr.numReferences; n++) { // check for '.rmFx' references 		
	 		//	msgHdr.getStringReference(n) = 
	 		// 	"1202409095568-924858015@Z3VlbnRlci53YWhsLm1lQHdlYi5kZQ==.rmFx"
				
				if ((msgHdr.getStringReference(n).indexOf(rmFx_ReferenceID) > -1) && 
					 (msgHdr.getStringReference(n).indexOf("@") > -1)) {
						nReferences = msgHdr.numReferences;
						dMode = false;
				}							
			}
		} // ---- END: check for 'References'
	
		// ---- check for 'Reminders' --------------------
		var messageId =  msgHdr.messageId;
		// strip out quotes as the extractHeader method returns some 
		// message-id's with extraneous quotes
		// like: "000c01c6941b$6ddb3c30$7be040"@foo.com
		messageId = messageId.replace(new RegExp(/\"/g),"");
	
		var reminderFoxEvents = reminderFox_getReminderEvents();
		
		for ( var i = 0; i < reminderFoxEvents.length; i++ ) {
			if (reminderFoxEvents[i].messageID =="<"+messageId+">") {
			//	reminder found in list
				rmFxID= reminderFoxEvents[i].id;
				dMode = false;
				break;
			}
		}	
		// ---- END check for 'Reminders' --------------------
		
		//  if valid 'enable' menu item for open msg by References/msgId
		if (dMode == false) {
			document.getElementById("mailRm_Open_" +xulId).removeAttribute("disabled");
		} else {
			document.getElementById("mailRm_Open_" +xulId).setAttribute("disabled", "true");			
		}										
	}
	
	var msg = ("menuPopUp Activate:"
					+	"\n xulId: " 	+ xulId
					+	"\n  nReferences: "	+ nReferences
					+	"\n  rmFxId: "			+ rmFxID);
	reminderFox_logMessageLevel(msg , 2);
}

