/**  //gW    add a 'reminder' with sending a message
 * 			
 * 2008-03-17	Send++ 
 * 				uses a MD5 coding of the sender account ('identity.email')
 * 				to stamp the outgoing msg with. Thus received msgs can be check if
 *             they have been send from this TB profile
 * 
 * 2008-01-24	set gCloseWindowAfterSave=true;
 * 2008-01-19	add TB-msg priority handling
 */
 
var rmFx_SwRm_FCC;
var rmFx_SwRm_Reference;
var rmFx_SwRm_identity;
var rmFx_ReferenceID = "reminderfox" 

var REMINDER_FOX_MAILID  = "mailids"
var rmFx_Prefs = Components.classes["@mozilla.org/preferences-service;1"]
					.getService(Components.interfaces.nsIPrefBranch);


function rmFx_msgSendwReminder () {	
// -----------------------------------------------------------

	var identity 		= gAccountManager.getIdentity(document.getElementById("msgIdentity").value);
	rmFx_SwRm_FCC 		= identity.fccFolder;			// 'send folder' for account
	
	var md5Id = md5String(identity.email).substring(0,8);
	// store md5Id to userPrefs
	rmFxStoreMD5Id(md5Id);
	
	var newDate = new Date();
	newDate.setDate(newDate.getDate() + 1);	// default to using tomorrow's date for reminder
	rmFx_SwRm_Reference =reminderFox_generateUniqueReminderId(newDate);

	var org_references = gMsgCompose.compFields.references;
	if (gMsgCompose.compFields.references == null || gMsgCompose.compFields.references == "") {
		gMsgCompose.compFields.references  =  "<" + rmFx_SwRm_Reference + "@" + md5Id +"." + rmFx_ReferenceID +">";
	} else {
		gMsgCompose.compFields.references += " <" + rmFx_SwRm_Reference + "@" + md5Id +"." +  rmFx_ReferenceID +">";
	}
	
	var mailIdentifierString = "[Send++]" // reminderFox_getBundle().getString("rf.add.mail.message.mail.identifier");
	var newReminderToBeAdded = new ReminderFoxEvent
		( rmFx_SwRm_Reference, newDate, mailIdentifierString + " " + gMsgSubjectElement.value );

	var msgCompFields = gMsgCompose.compFields;
	Recipients2CompFields(msgCompFields);

	var toAddress = msgCompFields.to;
	var ccAddress = msgCompFields.cc;
	var bccAddress = msgCompFields.bcc;

	newReminderToBeAdded.notes  = reminderFox_getBundle().getString("rf.add.mail.message.sender")	 
			+ ": " + identity.email  +  "\n";
	newReminderToBeAdded.notes +=	reminderFox_getBundle().getString("rf.add.mail.message.recipients")
			+ ": " + msgCompFields.to +  "\n";
		if (ccAddress != "") {
			newReminderToBeAdded.notes += "   CC:" + ccAddress + "\n";
		}		
		if (ccAddress != "") {
			newReminderToBeAdded.notes += "   BCC:" + bccAddress + "\n";
		}	
		
	var mailDate = new Date();
	mailDate.setDate(mailDate.getDate());   
	newReminderToBeAdded.notes += reminderFox_getBundle().getString("rf.add.mail.message.date")    	 
			+ ": " + rmFxMsgHdrDate(mailDate*1000) +  "\n";
	
	// TB PRIORITY definition converted for RmFx 	
	// the value is not language dependant!!  but the label="&highestPriorityCmd.label;"
	// = [string] "Highest"	= [string] "High"		===>> RmFx 'Important'=1
	// = [string] "Normal"
	// = [string] "Low"		= [string] "Lowest"
	
	if ((msgCompFields.priority == "Highest") || (msgCompFields.priority == "High")) {
			newReminderToBeAdded.priority = 1;		// set RmFx 'Important'=1
	}

	var added = reminderFox_addReminderHeadlessly(newReminderToBeAdded, false );

	if (added == false) {	// [CANCEL] NOT 'added' --> reset the 'References' and don't send
			gMsgCompose.compFields.references = org_references;
	} else {
		// now send the msg
		this.gCloseWindowAfterSave=true;
		GenericSendMessage(nsIMsgCompDeliverMode.Now);
		
		// how about fetching error from GenericSendMessage ???? ++++2do   ++++2do   ++++2do   
	}
}


///////////////////// -- open messages with  reminder reference -- /////////////
/*		Open a reminder with the "Edit Reminder" dialog using the 
 *    msgHdr "References" entry to check the "reminder-ID'.
 * 	a) for search with 'References'
 * 	b) for search of reminder.id of an msg
 * 
 * 	"Send with Reminder" adds an item 'References' to the message header
 * 	'reference-ID' :	"[string]@.reminderfox"
 * 	 - [string] build with reminderfox functions using time and random number,
 * 		 this [string] will also being used for reminders UID
 * 	 // - [address_base64] the senders mail-address base64 coded  // disabled 
 * 
 * 	A normal reply to such a msg will hold that header item value.  
 * 	This function will check for this reference-ID and use any such entry for 
 * 	a search and found-&-open of the initial reminder.
 * 	If multiple references are found a dialog with those reminder references
 * 	are displayed for selection.
 **/
function rmFxReminder4mailOpen(){
	// load all reminders
	var activeReminders = reminderFox_getReminderEvents();
   
	var msgHdr = gDBView.hdrForFirstSelectedMessage;
	var messageId =  msgHdr.messageId;
		// strip out quotes as the extractHeader method returns some message-id's with extraneous quotes
		// like: "000c01c6941b$6ddb3c30$7be040"@foo.com
	messageId = messageId.replace(new RegExp(/\"/g),"");

	// search in 'reminder' list for current msgID, if found open that event	
	for ( var i = 0; i < activeReminders.length; i++ ) {
		if (activeReminders[i].messageID =="<"+messageId+">") {
			//	reminder found in list
			var added = reminderFox_addReminderHeadlessly(activeReminders[i], true, true);
			return;
		}
	}	

	// so we don't have any reminder with current 'messageId'
	// now check for reminderfox-'References' in the current message hdr
	var reminderRef = null;
	var rmReferences = {};
	var nReferences = -1;
	var reminderUID;
	var reminderMD5;
	
	var currentMD5 = rmFx_Prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_MAILID);			
	
	if (msgHdr.numReferences > 0) {
		
		for (var n=0; n< msgHdr.numReferences; n++) { // check all 'rmFx' references 		
 //	msgHdr.getStringReference(n) = "1202409095568-924858015@Z3VlbnRlci53YWhsLm1lQHdlYi5kZQ==.rmFx"
			
			if ((msgHdr.getStringReference(n).indexOf(rmFx_ReferenceID) > -1) && 
				(msgHdr.getStringReference(n).indexOf("@") > -1))
			{
				if (nReferences == -1) { // there is one RmFx_SwRm reference .. minimum
					nReferences =0;
				}
				var fnd = msgHdr.getStringReference(n).indexOf("." + rmFx_ReferenceID );
				var reminderStr = msgHdr.getStringReference(n).substring(0,fnd);
			
				var fnd = reminderStr.indexOf( "@" );
				reminderMD5 = reminderStr.substring(fnd+1);		
				reminderUID = reminderStr.substring(0,fnd);
				
				// check if the mailMD5 id matches 
				if (currentMD5.indexOf(reminderMD5+',') > -1){
				// loop with all reminders and check for UID
					for (var nR =0; nR < activeReminders.length; nR++) {	
						if (reminderUID == activeReminders[nR].id ) { 
							nReferences++; // a reference found 
							
							rmReferences[nReferences] = activeReminders[nR];
							if (reminderRef == null) {
								reminderRef = nR; 
							} else {
								reminderRef += ";" + nR; 
							}
						}
					}
				} else {
					// alert("md5 mailAdr ***** NOT **** matched!")
				}
			}
		}
	}
	
	// here we have 
	//  - unkonwn msgID
	//  - References:
	//      -1 no References at all --> alert
	//       0 at least 1 References, but no match --> alert
	//       1 there is 1 References which match with 'reminder' list
	//      >1/default  more than 1 References, show list and ask user  
 
	switch (nReferences) {
		case -1:  { // no 'References' ... this should NOT be called because
						// the context menu item isn't enabled !!
			var msg1 = reminderFox_getBundle().getString("rf.sendw.reminder.ref1");
			var msg2 = reminderFox_getBundle().getString("rf.sendw.reminder.ref2");
			var msg3 = reminderFox_getBundle().getString("rf.sendw.reminder.ref3");
			alert (msg1 + "\n" + msg2 + "\n" +msg3);
			break;
		}
		case 0:  { 
			var msg1 = reminderFox_getBundle().getString("rf.sendw.reminder.ref4");
			var msg2 = reminderFox_getBundle().getString("rf.sendw.reminder.ref5");
			alert (msg1 + "\n" + msg2);
			break;
		}
		
		case 1:  {	// just one reference, go directly for "Edit Reminder" using 'reminderRef',
						// set the messageId and open headless		
			activeReminders[reminderRef].messageID = '<' + messageId + '>';					
			var added = reminderFox_addReminderHeadlessly
					(activeReminders[reminderRef], true, true);
	//  !!!!! using setTimeout will CRASH TB !!!!!				
	//		setTimeout(reminderFox_addReminderHeadlessly, 1, activeReminders[reminderRef], true, true);
			break;
		}

		default: { // multiple 'References' entries in a msg found, display them for selection
			var remOptions = { remNo: nReferences, rmReferences : rmReferences,
					msgSubject: msgHdr.subject, msgDate: msgHdr.date, msgFrom: msgHdr.author};   			
			var dlg = window.openDialog("chrome://reminderfox/content/mail/rmFxSendwReminderList.xul",
							"rmFxReminder4mailList", "chrome,centerscreen,resizable,dialog=no",  remOptions);
  		}	
	} // switch
}

function  rmFx_go4it() {
	
	var curMsg = document.getElementById('rmFx_ReferencesListbox');
	if (curMsg.currentIndex == -1) {
		window.close();
		return;
	}  // no item selected 
			
	var reminderUID = curMsg.childNodes[curMsg.currentIndex].value;
	var activeReminders = reminderFox_getReminderEvents();

	// search in 'reminder' list for current msgID, if found open that event	
	for ( var i = 0; i < activeReminders.length; i++ ) {
		if (activeReminders[i].id ==reminderUID) {
			//	reminder found in list, go for "Edit Reminder"
			var added = reminderFox_addReminderHeadlessly(activeReminders[i], true, true);
			return;
		}
	}	
	alert (reminderFox_getBundle().getString("rf.sendw.reminder.ref6"));	
}

function rmFxReminder4mailList() {
/*
 * 		<description id="idSubject" value="Subject: xxxxxxxxxx"></description>
			<description id="idDate" value="Date: yyyyyyyyy"></description>
			<description id="idFrom" value="From: zzzzzzzz"></description>
 */	
	var subject = window.arguments[0].msgSubject;
	document.getElementById('idSubject').setAttribute("value", "Subject: " + subject);
	
	var author = window.arguments[0].msgFrom;
	document.getElementById('idFrom').setAttribute("value", "From: " + author);

	var msgDate = rmFxMsgHdrDate (window.arguments[0].msgDate);
	document.getElementById('idDate').setAttribute("value", "Date: " + msgDate);
	
	var reminders = window.arguments[0].rmReferences;
	var remNo = window.arguments[0].remNo;

	for (var n=1; n < remNo+1; n++) {
		rmFxRListaddItem(n, 
			reminders[n].id,		reminders[n].summary,
			reminders[n].date,	reminders[n].notes);	
	}
	// preselect the first entry   ++++2do  ++++2do  ++++2do  ++++2do
	document.getElementById('rmFx_ReferencesListbox').setAttribute("index", "0");
}

function rmFxRListaddItem(n, msgId, subject, dateStr, notes) {
/*  this generate the list entries in form of:
		<richlistitem id="rmFxRefList" value="3333356789-1233"  
					style="border-bottom: 1px dotted sienna;">
			<vbox>
				<label value="Subject:XXXXX" style="font-weight: bold"/>
				<hbox><spacer width="20px"/><label value="Do 05.02.2008 13:30"/></hbox>
				<hbox><spacer width="20px"/><label value="Notes: xxxxxxxxxxxx"/></hbox>		
			</vbox>
		</richlistitem>
*/
		var rlBox = document.getElementById('rmFx_ReferencesListbox');
		var rlItem = document.createElement("richlistitem");
		rlBox.appendChild(rlItem);
			rlItem.setAttribute("id" , "rlItem" + n);
			rlItem.setAttribute("value" , msgId);
			rlItem.setAttribute("style" , "border-bottom: 1px dotted sienna;");
		// subject						
			var vbox0 = document.createElement("vbox");
			rlItem.appendChild(vbox0);
				vbox0.setAttribute("id" , "vbox0" + n);
				if (n == 1) {
					vbox0.setAttribute("selected" , "true" );
				}

				var labelS = document.createElement("label");
				vbox0.appendChild(labelS);
				var bText= reminderFox_getBundle().getString("rf.add.mail.message.subject")
					labelS.setAttribute("value", bText + ": " + subject);
					labelS.setAttribute("style" , "font-weight: bold");
		// date						
				var hboxD = document.createElement("hbox");
				vbox0.appendChild(hboxD);
					var spacer1 = document.createElement("spacer");
					hboxD.appendChild(spacer1);
					spacer1.setAttribute("width" , "20px");
					
					var labelD = document.createElement("label");
					var bText= reminderFox_getBundle().getString("rf.add.mail.message.date")
					hboxD.appendChild(labelD);
					labelD.setAttribute("value" , bText + ": " + dateStr);					
		// notes	
				if (notes != null ) {		
				var hboxN = document.createElement("hbox");
				vbox0.appendChild(hboxN);
					var spacer1 = document.createElement("spacer");
					hboxN.appendChild(spacer1);
					spacer1.setAttribute("width" , "20px");
					
					var labelN = document.createElement("label");
					hboxN.appendChild(labelN);
					var bText= reminderFox_getBundle().getString("rf.add.mail.message.notes")
					labelN.setAttribute("value" , bText + ": " + notes);
				}
}

function md5String(str) {
	var converter =
	  Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
	    createInstance(Components.interfaces.nsIScriptableUnicodeConverter);

	converter.charset = "UTF-8";
	var result = {};
	var data = converter.convertToByteArray(str, result);
	var ch = Components.classes["@mozilla.org/security/hash;1"]
	                   .createInstance(Components.interfaces.nsICryptoHash);
	ch.init(ch.MD5);
	ch.update(data, data.length);
	var hash = ch.finish(false);
	var s = [toHexString(hash.charCodeAt(i)) for (i in hash)].join("");
	return s;
}
// return the two-digit hexadecimal code for a byte
function toHexString(charCode) {
  return ("0" + charCode.toString(16)).slice(-2);
}

function 	rmFxStoreMD5Id(md5ID){
	//REMINDER_FOX_PREF = "extensions.reminderFox";
	//REMINDER_FOX_MAILIDS
	//add01986,a4db7cca,
	
	try {
		var currentMD5 = rmFx_Prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_MAILID);			
		// check if already stored
		if (currentMD5.indexOf(md5ID+',') == -1) {
			currentMD5 += md5ID+',';
		}		
	} catch(e) {
		currentMD5 = md5ID+",";
	}
	try {			
		rmFx_Prefs.setCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_MAILID, currentMD5);			
	} catch (e) {}	
}
